=== debian/changelog ===
chibicc (0+git20220719+ds-4) unstable; urgency=medium

  * d/control: restrict to only amd64.

 -- Gürkan Myczko <tar@debian.org>  Mon, 03 Oct 2022 08:59:27 +0200

chibicc (0+git20220719+ds-3) unstable; urgency=medium

  * d/control: restrict the architectures. (Closes: #1021025)

 -- Gürkan Myczko <tar@debian.org>  Sun, 02 Oct 2022 19:52:31 +0200

chibicc (0+git20220719+ds-2) unstable; urgency=medium

  * Pass CFLAGS to dh_auto_build. Thanks for the patch Vagrant Cascadian.
    (Closes: #1020719)

 -- Gürkan Myczko <tar@debian.org>  Mon, 26 Sep 2022 09:47:38 +0200

chibicc (0+git20220719+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1015797)

 -- Gürkan Myczko <tar@debian.org>  Tue, 19 Jul 2022 09:12:55 +0200
