=== debian/control ===
Source: chibicc
Section: devel
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.6.1
Homepage: https://github.com/rui314/chibicc
#Vcs-Browser: https://salsa.debian.org/debian/chibicc
#Vcs-Git: https://salsa.debian.org/debian/chibicc.git

Package: chibicc
Architecture: amd64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: small C compiler
 This is yet another small C compiler that implements most C11 features.
 Even though it still probably falls into the "toy compilers" category just
 like other small compilers do, chibicc can compile several real-world
 programs, including Git, SQLite, libpng and chibicc itself, without making
 modifications to the compiled programs. Generated executables of these
 programs pass their corresponding test suites. So, chibicc actually supports
 a wide variety of C11 features and is able to compile hundreds of thousands
 of lines of real-world C code correctly.
