=== debian/changelog ===
chibicc (0+git20240328+ds-2) unstable; urgency=medium

  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Mon, 15 Jul 2024 19:45:40 +0000

chibicc (0+git20240328+ds-1) unstable; urgency=medium

  * New upstream version. (Closes: #1066724)
  * d/rules: skip tests.

 -- Gürkan Myczko <tar@debian.org>  Thu, 28 Mar 2024 09:55:58 +0100
