=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: chibicc
 Section: devel
 Priority: optional
-Maintainer: Gürkan Myczko <tar@debian.org>
+Maintainer: Alex Myczko <tar@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Homepage: https://github.com/rui314/chibicc
 #Vcs-Browser: https://salsa.debian.org/debian/chibicc
 #Vcs-Git: https://salsa.debian.org/debian/chibicc.git
