=== debian/rules ===
--- 
+++ 
@@ -15,3 +15,9 @@
 
 override_dh_auto_build:
 	dh_auto_build -- CFLAGS="$(CFLAGS)"
+
+override_dh_auto_install:
+	@echo we dont use sudo.
+
+override_dh_auto_test:
+	@echo skip tests.
