=== debian/changelog ===
chibicc (1.0.23.1-1) unstable; urgency=medium

  * New upstream version.
  * d/upstream/metadata: updated.
  * d/copyright: bump years.
  * d/control:
    - update homepage field.
    - uncommented Vcf fields.
  * Bump standard version to 4.7.2.

 -- Alex Myczko <tar@debian.org>  Tue, 23 Sep 2025 12:11:36 +0200
