=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
-Standards-Version: 4.7.0
-Homepage: https://github.com/rui314/chibicc
-#Vcs-Browser: https://salsa.debian.org/debian/chibicc
-#Vcs-Git: https://salsa.debian.org/debian/chibicc.git
+Standards-Version: 4.7.2
+Homepage: https://github.com/stormalf/chibicc
+Vcs-Browser: https://salsa.debian.org/debian/chibicc
+Vcs-Git: https://salsa.debian.org/debian/chibicc.git
 
 Package: chibicc
 Architecture: amd64
