## chibicc 1.0.23.2

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,10 @@
+# The installation prefix
+PREFIX=/usr/local
+
+GCC_VERSION!=gcc -dumpversion
 CC=gcc
-CFLAGS =-std=c11 -g -fno-common -Wall -Wno-switch 
-CFLAGS_DIAG=-dotfile -std=c11 
+CFLAGS =-std=c11 -g -fno-common -Wall -Wno-switch -DPREFIX=\"$(PREFIX)\" -DGCC_VERSION=\"$(GCC_VERSION)\"
+CFLAGS_DIAG= -std=c11 
 OBJECT=chibicc
 OBJECTLIB=libchibicc
 SRCS=$(wildcard *.c)
@@ -53,9 +57,9 @@
 	for i in $^; do echo $$i; ./$$i || exit 1; echo; done
 	test/driver.sh ./stage2/$(OBJECT)
 
-projects-all: projects projects-oth git
+projects-all: projects projects-oth lxc vlc git memcached cpython openssl
 
-projects-oth: openssl vim nmap curl 
+projects-oth: vim nmap curl 
 
 projects: zlib util-linux nginx
 
@@ -67,10 +71,10 @@
 	cd ../zlib && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make test
 
 nmap:
-	cd ../nmap && make clean && CC=chibicc LDFLAGS="-fPIC -std=c11 -ldbus-1" LIBS="-ldbus-1 -latomic" ./configure --with-dbus && make && make check
+	cd ../nmap && make clean && CC=chibicc  CFLAGS="-fPIC -std=c11" LIBS="-ldbus-1 -latomic -libverbs -lrdmacm" ./configure --with-dbus && make && make check
 
 openssl:
-	cd ../openssl && make clean && CC=chibicc CFLAGS="-std=c11" ./configure && make 
+	cd ../openssl && make clean && CC=chibicc CFLAGS="-std=c11" ./Configure && make 
 
 util-linux:
 	cd ../util-linux && make clean && CC=chibicc CFLAGS="-fPIC -std=c11" ./configure && make && make check-programs && cd tests && ./run.sh
@@ -83,7 +87,7 @@
 
 lxc:
 	cd ../lxc && rm -rf build && CC=gcc \
-	meson setup build && cd build && sudo cp /usr/bin/gcc /usr/bin/gcc_backup \
+	meson setup build && cd build && sudo cp /usr/bin/gcc /usr/bin/gcc_backup  && \
 	sudo cp /usr/local/bin/chibicc /usr/bin/gcc && meson compile && sudo cp /usr/bin/gcc_backup /usr/bin/gcc
 
 vlc:
@@ -92,7 +96,7 @@
     make all
 
 cpython:
-	cd ../cpython && make clean && CC=chibicc ./configure \
+	cd ../cpython &&  CC=chibicc ./configure \
 	 --build=x86_64-pc-linux-gnu ac_cv_have_lchflags=no ac_cv_have_chflags=no && make && make test
 
 # vlc2:
@@ -122,14 +126,12 @@
 	rm -rf $(OBJECT) tmp* $(TESTS) issues/*.s issues/*.exe issues/*.dot test/*.s test/*.exe stage2 diagram/*.png test/*.dot $(OBJECTLIB)
 	find * -type f '(' -name '*~' -o -name '*.o' ')' -exec rm {} ';'
 
-install:
-	sudo rm -rf	/usr/local/include/x86_64-linux-gnu/chibicc && sudo rm -rf /usr/local/bin/chibicc
-	test -d /usr/local/include/x86_64-linux-gnu/chibicc || \
-		sudo mkdir -p /usr/local/include/x86_64-linux-gnu/chibicc
-	sudo cp -r include/* /usr/local/include/x86_64-linux-gnu/chibicc/
-	sudo cp ./chibicc /usr/local/bin/chibicc
+install: $(OBJECT)
+	install -v -D -m 755 -t $(PREFIX)/bin/ $(OBJECT)
+	install -v -D -m 644 -t $(PREFIX)/include/x86_64-linux-gnu/chibicc/ include/*
 
 uninstall:
-	sudo rm -rf	/usr/local/include/x86_64-linux-gnu/chibicc && sudo rm /usr/local/bin/chibicc
+	rm -f $(PREFIX)/bin/chibicc
+	rm -f $(PREFIX)/include/x86_64-linux-gnu/chibicc/*
 
 .PHONY: test clean test-stage2 libchibicc projects projects-all  projects-oth test-all install uninstall
