=== debian/changelog ===
chibicc (1.0.23.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Alex Myczko <tar@debian.org>  Wed, 17 Dec 2025 11:17:09 +0000

chibicc (1.0.23.2-1) experimental; urgency=medium

  * New upstream version.
  * d/control: drop Rules-Requires-Root.

 -- Alex Myczko <tar@debian.org>  Fri, 12 Dec 2025 13:36:16 +0000
